#if !defined(AFX_DEBUGWIN_H__D075A712_3D38_11D2_B7D2_0080C87E70D1__INCLUDED_)
#define AFX_DEBUGWIN_H__D075A712_3D38_11D2_B7D2_0080C87E70D1__INCLUDED_
// DebugWin.h : header file
//
#include "afxole.h"

/////////////////////////////////////////////////////////////////////////////
// DebugWin window
//#define CWnd CView
class CDebugWin : public CWnd
{
// Construction
protected:
	DECLARE_DYNCREATE(CDebugWin)
public:
	CDebugWin();
	int CCol;
	int CRow;

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDebugWin)
	virtual void OnDraw(CDC * dc);
	virtual bool Create(CWnd * parent);
	//}}AFX_VIRTUAL

// Implementation
public:
	bool m_CaretCreated;
	void UpdateCursor();
	CString m_Keys;
//	int OnCreate(LPCREATESTRUCT lpCreateStruct);
	bool UseCaret;
	void SetWinPtr(CDebugWin ** ptr);
	void ChangeSize(int rows,int cols=-1);
	COLORREF HighlightColor;
	int TabSize;
	void SetRed(CString &s);
	void CopyRange(int row1,int col1,int row2,int col2,bool Copy2File=false);
	int TopOffset;
	int MinCols;
	HGLOBAL Cmem;
	void DrawRectangle(CDC * pDC,CPoint P0,CPoint P1);
	bool DragActive;
	bool SelectionActive;
	CPoint TopLeft,BotRight;
	int MinRows;
	bool IsResized;
	bool AllowGrow;
	int Lines;
	bool IsScrolling;
	int FirstRow;
	int BlueRow;	// will show with blue background
	int RedRow;		// will show with red background
	int CharWidth;
	int CharHeight;
	void Resize();
	void SetFontHeight(int size);
	virtual ~CDebugWin();
	void SetChar(int row,int col,int c);
	BOOL SetText(int row, int col,const char * s,int len);
	void SetLine(int row,const char * s);
	void AddLine(char * s);
	void SetSize(int row, int col);
	void OnBeginPrinting(CDC * dcPrint,CPrintInfo *printInfo);
	void OnPrint(CDC * dc,CPrintInfo * pInfo);
	BOOL DoPreparePrinting(CPrintInfo* pInfo);
	bool GetFocus();
//	void SetWinPtr(CDebugWin ** ptr);
	bool IsActive();
	bool Show(bool show);
	void GotoRC(int row, int col);
	void ClrEOL();
	void Cls();
	// Generated message map functions
	int Cols;
 	int Rows;
protected:
	LOGFONT font;
	CDebugWin * * m_WinPtr;
protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	//{{AFX_MSG(CDebugWin)
	afx_msg void OnPaint();
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnFilePrint();
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCopyAll();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnEditCopyFile();
	afx_msg void OnEditCopy2File();
	afx_msg void OnUpdateEditCopy2File(CCmdUI* pCmdUI);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CFont * SelectFont(CDC * dc,bool SetHeight,CFont &Cfont);
	COleDataSource * ClipData;
	char * LastLine;
	int FontHeight;
	char * Data;
	bool m_IsActive;
	CString m_Title;
};

/////////////////////////////////////////////////////////////////////////////
#endif // !defined(AFX_DEBUGWIN_H__D075A712_3D38_11D2_B7D2_0080C87E70D1__INCLUDED_)

